"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrowLink = void 0;
var React = require("react");
function lightenDarkenColor(col, amt) {
    col = col.slice(1);
    var num = parseInt(col, 16);
    var r = (num >> 16) + amt;
    if (r > 255)
        r = 255;
    else if (r < 0)
        r = 0;
    var b = ((num >> 8) & 0x00FF) + amt;
    if (b > 255)
        b = 255;
    else if (b < 0)
        b = 0;
    var g = (num & 0x0000FF) + amt;
    if (g > 255)
        g = 255;
    else if (g < 0)
        g = 0;
    return "#" + (g | (b << 8) | (r << 16)).toString(16);
}
exports.ArrowLink = function (_a) {
    var link = _a.link, config = _a.config, linkColor = _a.linkColor, points = _a.points, isHovered = _a.isHovered, isSelected = _a.isSelected, startPos = _a.startPos, endPos = _a.endPos, onLinkMouseEnter = _a.onLinkMouseEnter, onLinkMouseLeave = _a.onLinkMouseLeave, onLinkClick = _a.onLinkClick;
    var startColor = config.linkGradientDelta ? lightenDarkenColor(linkColor, config.linkGradientDelta) : linkColor;
    var endColor = config.linkGradientDelta ? lightenDarkenColor(linkColor, -config.linkGradientDelta) : linkColor;
    var gradientName = linkColor.slice(1);
    var marker = { markerEnd: "url(#arrowHead" + gradientName + ")" };
    return (React.createElement("svg", { style: {
            overflow: 'visible',
            position: 'absolute',
            cursor: 'pointer',
            left: 0,
            right: 0,
        } },
        React.createElement("defs", null,
            React.createElement("marker", { id: "arrowHead" + gradientName, orient: "auto-start-reverse", markerWidth: "2", markerHeight: "4", refX: "0.1", refY: "2" },
                React.createElement("path", { d: "M0,0 V4 L2,2 Z", fill: endColor })),
            React.createElement("linearGradient", { id: "gradient" + gradientName + "A", x1: "0%", y1: "0%", x2: "0%", y2: "100%" },
                React.createElement("stop", { offset: "0%", stopColor: startColor }),
                React.createElement("stop", { offset: "10%", stopColor: startColor }),
                React.createElement("stop", { offset: "90%", stopColor: endColor }),
                React.createElement("stop", { offset: "100%", stopColor: endColor })),
            React.createElement("linearGradient", { id: "gradient" + gradientName + "B", x1: "0%", y1: "100%", x2: "0%", y2: "0%" },
                React.createElement("stop", { offset: "0%", stopColor: startColor }),
                React.createElement("stop", { offset: "10%", stopColor: startColor }),
                React.createElement("stop", { offset: "90%", stopColor: endColor }),
                React.createElement("stop", { offset: "100%", stopColor: endColor }))),
        React.createElement("path", __assign({ d: points, stroke: linkColor, strokeWidth: "3", fill: "none" }, marker)),
        React.createElement("path", __assign({ d: points, stroke: "url(#gradient" + gradientName + (startPos.y > endPos.y ? 'B' : 'A') + ")", strokeWidth: "3", fill: "none" }, marker)),
        React.createElement("path", { d: points, stroke: "url(#gradient" + gradientName + (startPos.y > endPos.y ? 'B' : 'A') + ")", strokeWidth: "20", fill: "none", strokeLinecap: "round", strokeOpacity: isHovered || isSelected ? 0.1 : 0, onMouseEnter: function () { return onLinkMouseEnter({ config: config, linkId: link.id }); }, onMouseLeave: function () { return onLinkMouseLeave({ config: config, linkId: link.id }); }, onClick: function (e) {
                onLinkClick({ config: config, linkId: link.id });
                e.stopPropagation();
            } })));
};
//# sourceMappingURL=ArrowLink.js.map