"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RegularLink = void 0;
var React = require("react");
function lightenDarkenColor(col, amt) {
    col = col.slice(1);
    var num = parseInt(col, 16);
    var r = (num >> 16) + amt;
    if (r > 255)
        r = 255;
    else if (r < 0)
        r = 0;
    var b = ((num >> 8) & 0x00FF) + amt;
    if (b > 255)
        b = 255;
    else if (b < 0)
        b = 0;
    var g = (num & 0x0000FF) + amt;
    if (g > 255)
        g = 255;
    else if (g < 0)
        g = 0;
    return "#" + (g | (b << 8) | (r << 16)).toString(16);
}
exports.RegularLink = function (_a) {
    var points = _a.points, linkColor = _a.linkColor, config = _a.config, link = _a.link, startPos = _a.startPos, endPos = _a.endPos, onLinkMouseEnter = _a.onLinkMouseEnter, onLinkMouseLeave = _a.onLinkMouseLeave, onLinkClick = _a.onLinkClick, isHovered = _a.isHovered, isSelected = _a.isSelected;
    var startColor = config.linkGradientDelta ? lightenDarkenColor(linkColor, config.linkGradientDelta) : linkColor;
    var endColor = config.linkGradientDelta ? lightenDarkenColor(linkColor, -config.linkGradientDelta) : linkColor;
    var gradientName = linkColor.slice(1);
    return (React.createElement("svg", { style: {
            overflow: 'visible',
            position: 'absolute',
            cursor: 'pointer',
            left: 0,
            right: 0,
        } },
        React.createElement("defs", null,
            React.createElement("linearGradient", { id: "gradient" + gradientName + "A", x1: "0%", y1: "0%", x2: "0%", y2: "100%" },
                React.createElement("stop", { offset: "0%", stopColor: startColor }),
                React.createElement("stop", { offset: "10%", stopColor: startColor }),
                React.createElement("stop", { offset: "90%", stopColor: endColor }),
                React.createElement("stop", { offset: "100%", stopColor: endColor })),
            React.createElement("linearGradient", { id: "gradient" + gradientName + "B", x1: "0%", y1: "100%", x2: "0%", y2: "0%" },
                React.createElement("stop", { offset: "0%", stopColor: startColor }),
                React.createElement("stop", { offset: "10%", stopColor: startColor }),
                React.createElement("stop", { offset: "90%", stopColor: endColor }),
                React.createElement("stop", { offset: "100%", stopColor: endColor }))),
        React.createElement("circle", { r: "4", cx: startPos.x, cy: startPos.y, fill: startColor }),
        React.createElement("path", { d: points, stroke: linkColor, strokeWidth: "3", fill: "none" }),
        React.createElement("path", { d: points, stroke: "url(#gradient" + gradientName + (startPos.y > endPos.y ? 'B' : 'A') + ")", strokeWidth: "3", fill: "none" }),
        React.createElement("path", { d: points, stroke: "url(#gradient" + gradientName + (startPos.y > endPos.y ? 'B' : 'A') + ")", strokeWidth: "20", fill: "none", strokeLinecap: "round", strokeOpacity: isHovered || isSelected ? 0.1 : 0, onMouseEnter: function () { return onLinkMouseEnter({ config: config, linkId: link.id }); }, onMouseLeave: function () { return onLinkMouseLeave({ config: config, linkId: link.id }); }, onClick: function (e) {
                onLinkClick({ config: config, linkId: link.id });
                e.stopPropagation();
            } }),
        React.createElement("circle", { r: "4", cx: endPos.x, cy: endPos.y, fill: endColor })));
};
//# sourceMappingURL=RegularLink.js.map