"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PortsDefault = void 0;
var React = require("react");
var __1 = require("../../");
var react_resize_observer_1 = require("react-resize-observer");
var react_1 = require("react");
exports.PortsDefault = function (_a) {
    var children = _a.children, config = _a.config, onResize = _a.onResize, scale = _a.scale;
    var _b = react_1.useState(0), top = _b[0], setTop = _b[1];
    var _c = react_1.useState(0), bottom = _c[0], setBottom = _c[1];
    var _d = react_1.useState(0), right = _d[0], setRight = _d[1];
    var _e = react_1.useState(0), left = _e[0], setLeft = _e[1];
    var _f = react_1.useState(0), width = _f[0], setWidth = _f[1];
    var _g = react_1.useState(0), height = _g[0], setHeight = _g[1];
    react_1.useEffect(function () {
        setWidth(Math.max(top, bottom));
    }, [top, bottom]);
    react_1.useEffect(function () {
        setHeight(Math.max(left, right));
    }, [left, right]);
    react_1.useEffect(function () {
        onResize({ width: width, height: height });
    }, [width, height, onResize]);
    return (React.createElement("div", null,
        React.createElement(__1.PortsGroupDefault, { config: config, side: "top", style: { marginLeft: -top / 2 } },
            React.createElement(react_resize_observer_1.default, { onResize: function (rect) { setTop(rect.width / scale); } }),
            children.filter(function (child) { return ['input', 'top'].includes(child.props.port.type); })),
        React.createElement(__1.PortsGroupDefault, { config: config, side: "bottom", style: { marginLeft: -bottom / 2 } },
            React.createElement(react_resize_observer_1.default, { onResize: function (rect) { setBottom(rect.width / scale); } }),
            children.filter(function (child) { return ['output', 'bottom'].includes(child.props.port.type); })),
        React.createElement(__1.PortsGroupDefault, { config: config, side: "right", style: { marginTop: -right / 2 } },
            React.createElement(react_resize_observer_1.default, { onResize: function (rect) { setRight(rect.height / scale); } }),
            children.filter(function (child) { return ['right'].includes(child.props.port.type); })),
        React.createElement(__1.PortsGroupDefault, { config: config, side: "left", style: { marginTop: -left / 2 } },
            React.createElement(react_resize_observer_1.default, { onResize: function (rect) { setLeft(rect.height / scale); } }),
            children.filter(function (child) { return ['left'].includes(child.props.port.type); }))));
};
//# sourceMappingURL=Ports.default.js.map